var doc = app.activeDocument;
var mySelection = doc.selection;
var selItem;
var namesSwatch = new Array();
var c;
var k = 0;
if (mySelection.length > 0){
	for (i = 0; i < mySelection.length; i++){
	  selItem = mySelection[i];

	  if (selItem.typename == 'PathItem'){
		get_Color(selItem);
	  }	else if (selItem.typename == 'CompoundPathItem') {
		get_Color(selItem.pathItems[0]);
	  }else{
		continue;
	  }
	  
	  if (i == 0){
		namesSwatch[0] = Name;
		c = false;
	  } else {
		include(Name);
		if (c == false){
		  k = k + 1;
		  namesSwatch[k] = Name;
		}
	  }
	  if (c == false) {
		var myGroup = doc.groupItems.add();
		myGroup.name = Name;
		selItem.moveToEnd(myGroup);
	  }
	  else{
		var myGroup = doc.groupItems.getByName(Name);
		selItem.moveToEnd(myGroup);
	  }
	}
}

function get_Color(item) {
	if (item.fillColor.typename == 'SpotColor'){
		Color = item.fillColor;
		Name = item.fillColor.spot.name;
		return;
	}
	if (item.fillColor.typename == 'RGBColor'){
		Color = new RGBColor();
		Color.red = item.fillColor.red;
		Color.green = item.fillColor.green;
		Color.blue = item.fillColor.blue;
		Name = Color.red.toString() + Color.green.toString() + Color.blue.toString();
		return;
	} 
	if (item.fillColor.typename == 'CMYKColor'){
		Color = new CMYKColor();
		Color.cyan = item.fillColor.cyan;
		Color.magenta = item.fillColor.magenta;
		Color.yellow = item.fillColor.yellow;
		Color.black = item.fillColor.black;
		Name = Color.cyan.toString() + Color.magenta.toString() + Color.yellow.toString() + Color.black.toString();
		return;
  }
}

function include(name) {
  var i = 0;
  while (i < namesSwatch.length){
    if (name == namesSwatch[i]) {
      return c = true;
    } else {
      c = false;
    }
    i = i+1;
  }
}








